<?php $docRoot = URL::getDocumentRoot(); ?>

<link href="<?php echo SITE . '/mg-admin/design/css/generalStyles.css?rev=' . filemtime($docRoot . '/mg-admin/design/css/generalStyles.css')?>" rel="stylesheet"></link>
<link rel="stylesheet" href="<?php echo SITE . '/mg-admin/design/css/modal-templates.css?rev=' . filemtime($docRoot . '/mg-admin/design/css/modal-templates.css') ?>">
<?php
// Необходимая информация о шаблонах
include_once ADMIN_DIR . '/section/views/layout/templates-info.php';
?>

<div class="first-templates-popup" id="first-templates-popup">
    <div class="first-templates-popup__body">
        <div class="first-templates-popup__content">
            <div class="templates-cards">
                <button class="first-templates-popup__close js-first-templates-popup__close">
                    <span class="visually-hidden">Закрыть</span>
                </button>
                <div class="first-templates-popup__container">
                    <div class="first-templates-popup__title">
                        Создайте свой уникальный внешний вид сайта
                    </div>
                    <div class="templates-cards__constructor <?php echo $tempSelected === 'mg-cloud-air' ? '_active' : '' ?>">
                        <picture class="templates-cards__constructor-image">
                            <source srcset="<?php echo SITE.'/'.'mg-templates/mg-cloud-air/images/mg-preview-desc.jpg' ?>, <?php echo SITE.'/'.'mg-templates/mg-cloud-air/images/mg-preview-desc_2x.jpg' ?> 2x">
                            <img loading="lazy" width="210" height="210"
                                src="<?php echo SITE . '/mg-admin/design/images/1x1.png' ?>"
                                alt="Изображение главной страницы шаблона-конструктора">
                        </picture>
                    </div>
                    <button type="button" class="first-templates-popup__button js-first-templates-popup__close">
                        Начать работу с конструктором
                    </button>
                </div>
                <div class="first-templates-popup__fixed-button js-first-templates-popup__fixed-button">
                    <button type="button" class="first-templates-popup__button js-first-templates-popup__close">
                        Начать работу с конструктором
                    </button>
                </div>
                <div class="first-templates-popup__title">
                    Или выберите один из готовых шаблонов
                </div>
                <div class="first-templates-popup__subtitle js-first-templates-popup__subtitle">
                    В готовых шаблонах отсутствует режим конструктора, но вы также можете менять внешний вид и содержимое
                </div>
                <div class="templates-cards__ready">
                    <?php
                    $count = 0;
                    foreach ($templates as $template) :
                        $count += 1;
                        $tempName = $template['foldername'];
                        if (!$tempName || $tempName === 'mg-cloud-air' || $tempName === 'moguta') continue; ?>
                        <div class="templates-cards__card js-first-templates-popup__card <?php echo $tempSelected === $tempName ? '_active' : '' ?>">
                            <div class="templates-cards__container">
                                <div class="templates-cards__card-image">
                                    <img loading="lazy" width="210" height="210"
                                        class="<?php echo $template['image-preview'] !== '' && $tempName !== 'mg-jasmine' ? '_slide' : '' ?>"
                                        src="<?php echo $template['image-preview'] ?>"
                                        srcset="<?php echo $template['image-preview_2x'] ?> 2x"
                                        alt="Изображение шаблона <?php echo $tempName ?>">
                                </div>
                                <span class="templates-cards__card-title templates-cards__card-title_description">
                                    <?php echo !empty($tempsInfo[$tempName]['description']) ? $tempsInfo[$tempName]['description'] : 'Шаблон № ' . $count ?>
                                </span>
                            </div>
                            <div class="templates-cards__card-buttons">
                                <?php if ($tempsInfo[$tempName]['link']) : ?>
                                    <button type="button" class="templates-cards__card-demo js-first-templates-popup__demo" data-temp-name="<?php echo $tempName ?>" data-src-demo="<?php echo $tempsInfo[$tempName]['link'] ?>">Демо</button>
                                <?php endif; ?>
                                <button type="button" class="templates-cards__card-button js-first-templates-popup__activation" data-temp-name="<?php echo $tempName ?>" data-color="<?php echo $tempsInfo[$tempName]['color'] ?>">
                                    <?php echo $tempSelected === $tempName ? 'Установлен' : 'Установить' ?>
                                </button>
                            </div>
                        </div>
                    <?php endforeach; ?>
                </div>
            </div>

            <div class="templates-iframe js-first-templates-iframe">
                <div class="templates-iframe__header">
                    <div class="templates-iframe__container">
                        <div class="templates-iframe__temp-name js-first-templates-iframe__name"></div>
                        <div class="templates-iframe__text">
                            Демонстрационный сайт<span>. Можете установить этот шаблон, чтобы ваш сайт выглядел также</span>
                        </div>
                    </div>
                    <button class="templates-iframe__close js-firsttemplates-iframe__close">
                        <span class="first-templates-popup__close_text"> Закрыть </span>
                        <span class="first-templates-popup__close templates-iframe__cross"></span>
                    </button>
                </div>
                <iframe src="" frameborder="0" class="js-first-templates-popup__iframe"></iframe>
            </div>
        </div>
    </div>
</div>

<script>
    includeJS("<?php echo SITE ?>/mg-core/script/admin/first-modal-templates.js");
</script>